-- 自选礼包
Lua_GiftSelectionWindow = class("Lua_GiftSelectionWindow", Lua_Window);
function Lua_GiftSelectionWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GiftSelectionWindow";
	self.skinName = "GiftSelectionWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GiftSelectionWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.selectedList = Array();
	self:addLuaEvent("GIFT_ITEM_SELECT", self, self.onGiftItemSelect);

	self.itemList = Lua_DragList.new(self.content, 600, 255, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, 2.5);
	self.itemList:setListCell(Lua_GiftSelectionItem, 112, 112, 5);
	self.itemList:setCellSpacing(10, 10);

    self.btnCancel:addClickFuntion(self, self.onBtnCancelClick);
    self.btnSure:addClickFuntion(self, self.onBtnSureClick);
end

function Lua_GiftSelectionWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self.selectedList = nil;
	self:superCall("dispose");
end

function Lua_GiftSelectionWindow:showWin(param)
	self:superCall("showWin", param);
	if param == nil or param.data == nil or param.data.client_goods_list == nil then
		self:hide();
		return;
	end

	self.desText.text = LanUtil.formateStr(309034, tostring(param.data.option_amount));
	local list = param.data.client_goods_list;
	local config = getConfig({ "option_gift" });
	local arr = Array();
	local id;
	local tvo;
	for i = 1, #list do
		id = list[i];
		tvo = Lua_ToolVo.createToolVo(config[id].item_id, config[id].item_amount);
		arr:add({ optionId = id, tvo = tvo });
	end
	self.itemList:setArrayData(arr);
end

function Lua_GiftSelectionWindow:onGiftItemSelect(optionId)
	local index = self.selectedList:indexOf(optionId);
	if index == -1 then
		if self.selectedList:getSize() >= self.showData.data.option_amount then
			OperateAlert.show(LanUtil.formateStr(309035, tostring(self.showData.data.option_amount)));
			return;
		end
		self.selectedList:add(optionId);
	else
		self.selectedList:remove(index);
	end

	local showList = self.itemList.showList;
	for i = 1, showList:getSize() do
		showList[i]:updateSelected(self.selectedList);
	end
end

function Lua_GiftSelectionWindow:onBtnCancelClick(go)
	self:hide();
end

function Lua_GiftSelectionWindow:onBtnSureClick(go)
	local data = self.showData.data;
		if self.selectedList:getSize() < data.option_amount then
			OperateAlert.show(LanUtil.formateStr(309034, tostring(data.option_amount)));
		return;
	end

	-- local haveCount = DataCenter.packData:getItemCountById(data.id);
	-- if haveCount > 1 then
	-- 	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = 1, selectedList = self.selectedList});
	-- else
	-- 	Lua_ProxyManager.getProxy("Lua_PackProxy"):sUseItem(data.pack_type, data.unique_id, 1, self.selectedList);
	-- end
	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = 1, selectedList = self.selectedList});
	self:hide();
end




















Lua_GiftSelectionItem = class("Lua_GiftSelectionItem", Lua_ListCell);
function Lua_GiftSelectionItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
end

function Lua_GiftSelectionItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_GiftSelectionItem:setCustomParam(customParam)
	self.customParam = customParam;
end

function Lua_GiftSelectionItem:setData(data)
	self.data = data;
	self.itemIcon:setData(data.tvo);
	self:updateSelected(self.selectedList);
end

function Lua_GiftSelectionItem:updateSelected(selectedList)
	self.selectedList = selectedList;
	if self.data == nil or selectedList == nil or selectedList:indexOf(self.data.optionId) == -1 then
		self.itemIcon:setDrawMask(false);
	else
		self.itemIcon:setDrawMask(true);
	end
end

function Lua_GiftSelectionItem:onPressClick()
	if self.data == nil then
		return;
	end
	Lua_MsgUtil.callFunc("GIFT_ITEM_SELECT", self.data.optionId);
end