Lua_HeroItemDetailsWindow = class("Lua_HeroItemDetailsWindow", Lua_Window)
function Lua_HeroItemDetailsWindow:ctor()
	self:superCall("ctor")

	self.w = 396
	self.windowName = "Lua_HeroItemDetailsWindow"
	self.skinName = "HeroItemDetailsWindow_skin"
	self.showBlackMask = true
	self.blackAlpha = 0.6
	self.isClickClose = true
end

function Lua_HeroItemDetailsWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.itemIcon = Lua_ItemIcon.new(self.showObject)
	self.itemIcon:setLocation(-121.5, -54.5, 0)
	self.itemIcon:setScale(0.8, 0.8, 0.8)
end

function Lua_HeroItemDetailsWindow:dispose()
	if self.itemIcon then
		self.itemIcon:dispose()
		self.itemIcon = nil
	end
	if self.btnArr ~= nil then
		self.btnArr:dispose()
		self.btnArr:clear()
		self.btnArr = nil
	end
	self.data = nil
	self:superCall("dispose")
end

function Lua_HeroItemDetailsWindow:showWin(param)
	self:superCall("showWin", param)
	self.data = param.data
	self.isShowBtns = param.isShowBtns
	self:updateShowInfo()
end

function Lua_HeroItemDetailsWindow:updateShowInfo()
	self.winBg:setAltas("common_altas_1", "ui_common_window_04"..(self.data.color - 1))

	self.itemIcon:setData(self.data)
	self.itemIcon:showNum(0)
	self.nameText.text = self.data.name

	local heroConfig = Lua_HeroConfigData.getConfig(self.data.hero_id)
	self.titleText.text = heroConfig.title

	self.desText.text = self.data.des
	self.desText:resetSize()

	local minH = 122
	local spacingH = 14 -- 间距
	local addH = 0

	addH = addH + self.desText.height
	self.line:setLocation(0, self.desText.posY - self.desText.height - spacingH, 0)
	
	local list = self.data.buttonList
	if list == nil or #list <= 0 then
		self.isShowBtns = false
	end
	local btnStartY = self.line.posY - spacingH
	local btnH = self:showButtonList(list, btnStartY)
	if btnH > 0 then
		self.line:setEnable(true)
		addH = addH + self.line.height + spacingH -- 分割线与文本的间距
		addH = addH + btnH + spacingH -- 与分割线的间距
	else
		self.line:setEnable(false)
		addH = addH + spacingH
	end

	self.winBg:SetDimensions(self.w, minH + addH)
	LuaUtil.setObjPos(self.showObject, 0, self.winBg.height / 2, 0)
end

function Lua_HeroItemDetailsWindow:showButtonList(list, startY)
	if self.isShowBtns ~= true then
		return 0
	end

	if self.btnArr == nil then
		self.btnArr = Array()
	end
	local arr = Array()
	local obj
	if list ~= nil then
		for i = 1, #list do
			obj = list[i]
			if self.data.expired_tick ~= nil and self.data.expired_tick > 0 then
				if self.data.isExpired then
					if obj == 4 then
						arr:add(obj)
					end
				else
					if obj ~= 4 then
						arr:add(obj)
					end
				end
			else
				arr:add(obj)
			end
		end
	end

	local num = arr:getSize()
	local len = self.btnArr:getSize()
	local maxLen = num > len and num or len

	local style = 13
	local width = 130
	local height = 51
	local startX
	local spacingX
	local spacingY = 58
	local count
	if num == 1 then
		style = 11
		width = 156
		startX = 0
		spacingX = 0
		count = 1
	elseif num == 2 then
		style = 11
		width = 156
		startX = -104
		spacingX = 205
		count = 2
	elseif num == 3 then
		startX = -137.5
		spacingX = 137.5
		count = 3
	elseif num == 4 then
		style = 11
		width = 156
		startX = -104
		spacingX = 205
		count = 2
	elseif num == 5 then
		startX = -137.5
		spacingX = 137.5
		count = 3
	elseif num == 6 then
		startX = -137.5
		spacingX = 137.5
		count = 3
	end

	local btn
	local posX
	local posY
	for i = 1, maxLen do
		btn = self.btnArr[i]
		if i > num then
			if btn ~= nil then
				btn:setEnable(false)
			end
		else
			if btn == nil then
				btn = UICreate.createButton(self.showObject, nil, 0, 0, width, height)
				self.btnArr:add(btn)
			else
				btn:setEnable(true)
			end
			btn.pivotValue = 1
			btn:SetDimensions(width, height)
			btn:setStyle(style)
			btn.txt:setLocation(0, 0, 0)
			btn.txt.fontSize = 26
			btn.txt.colorStr = Lua_ColorDefine.transColorStr("3D424F")
			btn:setLangValue(309010 + arr[i])
			btn.name = tostring(arr[i])
			posX = startX + ((i - 1) % count) * spacingX
			posY = startY + Mathf.Floor((i - 1) / count) * -spacingY
			if num == 5 and i == num then
				posX = posX + spacingX
			end
			btn:setLocation(posX, posY, 0)
			btn:addClickFuntion(self, self.onButtonClick)
		end
	end

	if num < 4 then
		return height
	end
	return height * 2
end

function Lua_HeroItemDetailsWindow:onButtonClick(go)
	DataCenter.packUtil:doActClick(self.data, tonumber(go.name))
end