-- 道具详情
Lua_ItemDetailsPanel = class("Lua_ItemDetailsPanel", Lua_DisplayObject);
function Lua_ItemDetailsPanel:ctor(p, skin, frameBuild)
	self:superCall("ctor", p, skin, frameBuild);
end

function Lua_ItemDetailsPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.desText = UICreate.createLabel(self.content, nil, -177, 0, 360, 31, 24);
	self.desText.siblingIndex = 0;
	self.desText.pivotValue = 0
	self.desText.alignmentValue = 0;
	self.desText.horizontalOverflowValue = 0;
	self.desText.verticalOverflowValue = 1;
	self.desText.colorStr = Lua_ColorDefine.transColorStr("C1BDB6")
end

function Lua_ItemDetailsPanel:dispose()
	if self.textArea ~= nil then
		self.textArea:dispose();
		self.textArea = nil;
	end
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	if self.btnArr ~= nil then
		self.btnArr:dispose();
		self.btnArr:clear();
		self.btnArr = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ItemDetailsPanel:setData(param)
	self.data = param.data;
	self.isShowBtns = param.isShowBtns;

	local maxH = 871; -- 没有按钮的最大高度
	local spacingH = 28; -- 间距
	local addH = 0;

	local len;
	local list = self.data.client_goods_list;
	local giftArr = Array();
	local giftSize = Mathf.Ceil(112 * 0.6);
	local giftSpacingW = 10;
	local giftSpacingH = 5;
	local giftW = giftSize * 5 + giftSpacingW * 4;
	local giftH = 0;
	if list ~= nil then
		local config = getConfig({ "option_gift" });
		local id;
		local tvo;
		for i = 1, #list do
			id = list[i];
			tvo = Lua_ToolVo.createToolVo(config[id].item_id, config[id].item_amount);
			giftArr:add(tvo);
		end

		len = giftArr:getSize();
		if len > 10 then
			giftH = giftSize * 2 + giftSize / 2 + giftSpacingH * 2;
		elseif len > 5 then
			giftH = giftSize * 2 + giftSpacingH;
		else
			giftH = giftSize;
		end
		self:showGiftList(giftW, giftH, giftSize, giftSize, giftSpacingW, giftSpacingH, giftArr);
	end

	local btnStartY;
	if giftH > 0 then
		local desHeight = self:showDes(self.data, maxH - giftH - spacingH); -- spacingH是描述与礼包之间的间距
		self.giftList:setLocation(0, self.desText.posY - desHeight - spacingH, 0);

		addH = addH + giftH + desHeight + spacingH;
		btnStartY = self.giftList.posY - giftH - spacingH;
	else
		local desHeight = self:showDes(self.data, maxH);
		addH = addH + desHeight;
		btnStartY = self.desText.posY - desHeight - spacingH;
	end

	list = self.data.buttonList;
	if list == nil or #list <= 0 then
		self.isShowBtns = false;
	end

	-- 非背包展示的英雄碎片显示详情按钮
	if param.showDetails ~= false and self.data.main_type == Lua_PackDefine.HERO_CHIP_FIXED then
		self.isShowBtns = true;
		list = {5};
	end

	local btnH = self:showButtonList(list, btnStartY);
	if btnH > 0 then
		addH = addH + btnH + spacingH; -- spacingH是按钮与前面显示区的间距
	end

	return addH;
end

function Lua_ItemDetailsPanel:showGiftList(rectW, rectH, cellW, cellH, intervalW, intervalH, arr)
	if self.giftList == nil then
		self.giftList = Lua_DragList.new(self.content, rectW, rectH, Lua_AxisDefine.Vertical);
		self.giftList:setRectPivot(1);
		self.giftList:setListCell(Lua_GiftItemCell, cellW, cellH, 5);
		self.giftList:setCellSpacing(intervalW, intervalH);
	end
	self.giftList:setArrayData(arr);
	self.giftList.canDrag = not self.giftList.bDragEnd;
end

function Lua_ItemDetailsPanel:showDes(data, desMaxH)
	self.desText:setEnable(true);
	self.desText.text = data.des;
	self.desText:resetSize();
	local height = self.desText.height;
	if height > desMaxH then
		height = desMaxH;
		self.desText:setEnable(false);
		if self.textArea == nil then
			self.textArea = Lua_TextArea.new(self.content, 360, height, 1);
			self.textArea:setLocation(0, self.desText.posY, 0);
		end
		self.textArea:setText(data.des, 24);
	end
	return height;
end

function Lua_ItemDetailsPanel:showButtonList(list, startY)
	if self.isShowBtns ~= true then
		return 0;
	end

	if self.btnArr == nil then
		self.btnArr = Array();
	end
	local arr = Array();
	local obj;
	if list ~= nil then
		for i = 1, #list do
			obj = list[i];
			if self.data.expired_tick ~= nil and self.data.expired_tick > 0 then
				if self.data.isExpired then
					if obj == 4 then
						arr:add(obj);
					end
				else
					if obj ~= 4 then
						arr:add(obj);
					end
				end
			else
				arr:add(obj);
			end
		end
	end

	local num = arr:getSize();
	local len = self.btnArr:getSize();
	local maxLen = num > len and num or len;

	local style = 13;
	local width = 130;
	local height = 51;
	local startX;
	local spacingX;
	local spacingY = 58;
	local count;
	if num == 1 then
		style = 11;
		width = 156;
		startX = 0;
		spacingX = 0;
		count = 1;
	elseif num == 2 then
		style = 11;
		width = 156;
		startX = -104;
		spacingX = 205;
		count = 2;
	elseif num == 3 then
		startX = -137.5;
		spacingX = 137.5;
		count = 3;
	elseif num == 4 then
		style = 11;
		width = 156;
		startX = -104;
		spacingX = 205;
		count = 2;
	elseif num == 5 then
		startX = -137.5;
		spacingX = 137.5;
		count = 3;
	elseif num == 6 then
		startX = -137.5;
		spacingX = 137.5;
		count = 3;
	end

	local btn;
	local posX;
	local posY;
	for i = 1, maxLen do
		btn = self.btnArr[i];
		if i > num then
			if btn ~= nil then
				btn:setEnable(false);
			end
		else
			if btn == nil then
				btn = UICreate.createButton(self.content, nil, 0, 0, width, height);
				self.btnArr:add(btn);
			else
				btn:setEnable(true);
			end
			btn.pivotValue = 1;
			btn:SetDimensions(width, height);
			btn:setStyle(style);
			btn.txt:setLocation(0, 0, 0);
			btn.txt.fontSize = 26;
			btn.txt.colorStr = Lua_ColorDefine.transColorStr("3D424F");
			btn:setLangValue(309010 + arr[i]);
			btn.name = tostring(arr[i]);
			posX = startX + ((i - 1) % count) * spacingX;
			posY = startY + Mathf.Floor((i - 1) / count) * -spacingY;
			if num == 5 and i == num then
				posX = posX + spacingX;
			end
			btn:setLocation(posX, posY, 0);
			btn:addClickFuntion(self, self.onButtonClick);
		end
	end

	if num < 4 then
		return height;
	end
	return height * 2;
end

function Lua_ItemDetailsPanel:onButtonClick(go)
	DataCenter.packUtil:doActClick(self.data, tonumber(go.name));
end




















Lua_GiftItemCell = class("Lua_GiftItemCell", Lua_ItemIconCell);
function Lua_GiftItemCell:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon:setScale(0.6, 0.6, 0.6);
end

function Lua_GiftItemCell:setData(data)
    self:superCall("setData", data);
    self.itemIcon:showNum(0);
    self:showNum(data.count);
end

function Lua_GiftItemCell:onPressClick()
    if self.data == nil then
        return;
    end
    DataCenter.packUtil:showItemInfo(self.data, false);
end

function Lua_GiftItemCell:showNum(num)
    if num == nil or num <= 1 then
        if self._txt_right_down ~= nil then
            self._txt_right_down:setEnable(false);
        end
    else
        if self._txt_right_down == nil then
            self._txt_right_down = UICreate.createLabel(self.content, nil, 26, -20, 100, 31, 16);
            self._txt_right_down.pivot = Lua_WindowUtil.getPivot(5);
            self._txt_right_down.fontName = Lua_MyUISettings.fangzhengFontName;
            self._txt_right_down.alignmentValue = 5;
            self._txt_right_down.horizontalOverflowValue = 1;
            self._txt_right_down.effectStyle = 2;
            self._txt_right_down.colorStr = Lua_ColorDefine.transColor("EFF1E4");
            self._txt_right_down.effectColorStr = Lua_ColorDefine.transColor("424242");
            self._txt_right_down:setEffectDistance(2, 2);
        end
        self._txt_right_down:setEnable(true);
        self._txt_right_down.text = num;
    end
end