checkRequire("Lua_ItemDetailsPanel");
checkRequire("Lua_ItemBatchPanel");
Lua_ItemDetailsWindow = class("Lua_ItemDetailsWindow", Lua_Window);
function Lua_ItemDetailsWindow:ctor()
    self:superCall("ctor");

    self.w = 436;
    self.showBlackMask = true;
    self.blackAlpha = 0.6;
    self.isClickClose = true;
    self.windowName = "Lua_ItemDetailsWindow";
    self.skinName = "ItemDetailWindow_skin";
end

function Lua_ItemDetailsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.showObject);
    self.itemIcon:setLocation(-126, -93, 0);

    self.sourceIcon:addClickFuntion(self, self.onCheckSource);
    self.sourceText:addClickFuntion(self, self.onCheckSource);
end

function Lua_ItemDetailsWindow:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self:superCall("dispose");
end

function Lua_ItemDetailsWindow:showWin(param)
    self:superCall("showWin", param);
    self:showInfo(param.data);
    self:updateShowInfo();
end

function Lua_ItemDetailsWindow:updateShowInfo()
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end

    if self.showData.actVal == nil then
        self.curPanel = Lua_ItemDetailsPanel.new(self.showObject); -- 道具详情
    else
        self.curPanel = Lua_ItemBatchPanel.new(self.showObject); -- 道具批量处理
    end
    self.curPanel:setLocation(0, -203, 0);

    local minH = 268 - 31; -- 没有按钮的最小高度 31是效果图中描述默认的高度
    local addH = self.curPanel:setData(self.showData);
    addH = addH == nil and 0 or addH
    self.winBg:SetDimensions(self.w, minH + addH);
    LuaUtil.setObjPos(self.showObject, 0, self.winBg.height / 2, 0);
end

function Lua_ItemDetailsWindow:showInfo(data)
    self.itemIcon:setData(data);
    self.itemIcon:showNum(0);
    self.nameText.text = data.colorName;

    self.useText.text = data.effect_des;
    if data.main_type == Lua_PackDefine.HERO or self.showData.actVal ~= nil then
        self.haveText:setEnable(false);
    else
        local count = DataCenter.packData:getItemCountById(data.id);
        self.haveText:setEnable(true);
        self.haveText.text = LanUtil.formateStr(309010, numberTrans(count));        
    end
    if strIsNullOrEmpty(data.effect_des) then
        self.haveText:setLocation(-50, -92, 0)
    else
        self.haveText:setLocation(60, -92, 0)
    end

    self.sourceObject:SetActive(data.showPath == 1);
end

function Lua_ItemDetailsWindow:onCheckSource(go)
    DataCenter.packUtil:openPathWindow(self.showData.data, false);
    self:hide();
end