checkRequire("Lua_PackPanel");
Lua_PackChipPanel = class("Lua_PackChipPanel", Lua_PackPanel);
function Lua_PackChipPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PackChipPanel:buildShowItem()
	self:superCall("buildShowItem");

    self.itemList:setListCell(Lua_PackChipItem, 112, 150, 5);
    self.itemList:setCellSpacing(15, 0);
end

function Lua_PackChipPanel:initEvent()
	self:addLuaEvent("ADD_PACK_ITEMS", self, self.addItem);
	self:addLuaEvent("REMOVE_PACK_ITEMS", self, self.removeItem);
end

function Lua_PackChipPanel:setData(data)
	self.data = data;
	self:createButton();

	self.itemArr, self.itemDic = DataCenter.packData:getPackArrByPackType(data.package);
	self:updateListInfo(self.itemArr);
end




















Lua_PackChipItem = class("Lua_PackChipItem", Lua_ListCell);
function Lua_PackChipItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PackChipItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 15, 0);

	self.bar = UICreate.createProgressBar(self.content, "common_altas_1", "ui_common_progress_006_b", "common_altas_1", "ui_common_progress_006_f", 0, -60, 105, 15);
	self.bar:setBarOffset(2, 2);
	self.bar.txt.fontSize = 18;
	self.bar.txt.effectStyle = 2;
	self.bar.txt.effectColorStr = Lua_ColorDefine.transColorStr("9D8A77");
	self.bar.txt:setEffectDistance(2, 2);
end

function Lua_PackChipItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_PackChipItem:setData(data)
	self.data = data;
	if type(data) == "number" then
		if data == 0 then
			self.data = nil;
		else
			self.data = DataCenter.packData:getItemVoByUnId(data);
		end
	end

	self.itemIcon:setData(self.data);
	self.itemIcon:showRedPoint(self.data.isShowHeroChipRed or self.data.isShowChipRed);
	self.itemIcon:showUseLogo(self.data.use_logo == 1);
	self.itemIcon:showNum(0);
	if self.data == nil or self.data.compound == nil then
		self.bar:setEnable(false);
	else
		self.bar:setEnable(true);
		local maxValue = self.data.compound[2];
		local value = self.data.count;
		self.bar:setMaxValue(maxValue);
		self.bar:setValue(value);
		self.bar:setText(value.."/"..maxValue);
	end
end

function Lua_PackChipItem:onPressClick()
	if self.data == nil or self.data.id == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data, true, false);
end

function Lua_PackChipItem:onMouseDownHandle()
	self.itemIcon:setScale(0.95, 0.95, 0.95);
end

function Lua_PackChipItem:onMouseUpHandle()
	self.itemIcon:setScale(1, 1, 1);
end